OGRE-Next: Ogre::v1::GL3PlusDefaultHardwareIndexBuffer Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::v1::GL3PlusDefaultHardwareIndexBuffer Class Referencefinal

Specialisation of HardwareIndexBuffer for emulation. More...

`#include <OgreGL3PlusDefaultHardwareBufferManager.h>`

Inheritance diagram for Ogre::v1::GL3PlusDefaultHardwareIndexBuffer:
[legend]

## Public Member Functions
| GL3PlusDefaultHardwareIndexBuffer (IndexType idxType, size_t numIndexes, HardwareBuffer::Usage usage)
| ~GL3PlusDefaultHardwareIndexBuffer () override
void * | getDataPtr (size_t offset) const
void * | lock (size_t offset, size_t length, LockOptions options) override
| Override HardwareBuffer to turn off all shadowing.
void | readData (size_t offset, size_t length, void *pDest) override
| Reads data from the buffer and places it in the memory pointed to by pDest.
void | unlock () override
| Override HardwareBuffer to turn off all shadowing.
void | writeData (size_t offset, size_t length, const void *pSource, bool discardWholeBuffer=false) override
| Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough.
Public Member Functions inherited from Ogre::v1::HardwareIndexBuffer
| HardwareIndexBuffer (HardwareBufferManagerBase *mgr, IndexType idxType, size_t numIndexes, HardwareBuffer::Usage usage, bool useSystemMemory, bool useShadowBuffer)
| Should be called by HardwareBufferManager.
| ~HardwareIndexBuffer ()
size_t | getIndexSize () const
| Get the size in bytes of each index.
HardwareBufferManagerBase * | getManager () const
| Return the manager of this buffer, if any.
size_t | getNumIndexes () const
| Get the number of indexes in this buffer.
IndexType | getType () const
| Get the type of indexes used in this buffer.
Public Member Functions inherited from Ogre::v1::HardwareBuffer
| HardwareBuffer (Usage usage, bool systemMemory, bool useShadowBuffer)
| Constructor, to be called by HardwareBufferManager only.
virtual | ~HardwareBuffer ()
virtual void | _updateFromShadow ()
| Updates the real buffer from the shadow buffer, if required.
virtual void | copyData (HardwareBuffer &srcBuffer)
| Copy all data from another buffer into this one.
virtual void | copyData (HardwareBuffer &srcBuffer, size_t srcOffset, size_t dstOffset, size_t length, bool discardWholeBuffer=false)
| Copy data from another buffer into this one.
virtual void * | getRenderSystemData ()
| An internal function that should be used only by a render system for internal use.
size_t | getSizeInBytes () const
| Returns the size of this buffer in bytes.
Usage | getUsage () const
| Returns the Usage flags with which this buffer was created.
bool | hasShadowBuffer () const
| Returns whether this buffer has a system memory shadow for quicker reading.
bool | isLocked () const
| Returns whether or not this buffer is currently locked.
bool | isSystemMemory () const
| Returns whether this buffer is held in system memory.
void * | lock (LockOptions options)
| Lock the entire buffer for (potentially) reading / writing.
void | suppressHardwareUpdate (bool suppress)
| Pass true to suppress hardware upload of shadow buffer changes.

## Additional Inherited Members
Public Types inherited from Ogre::v1::HardwareIndexBuffer
typedef Ogre::IndexType | IndexType
Public Types inherited from Ogre::v1::HardwareBuffer
enum | LockOptions { HBL_NORMAL , HBL_DISCARD , HBL_READ_ONLY , HBL_NO_OVERWRITE , HBL_WRITE_ONLY }
| Locking options. More...
enum | Usage { HBU_STATIC = 1 , HBU_DYNAMIC = 2 , HBU_WRITE_ONLY = 4 , HBU_DISCARDABLE = 8 , HBU_STATIC_WRITE_ONLY = 5 , HBU_DYNAMIC_WRITE_ONLY = 6 , HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE = 14 }
| Enums describing buffer usage; not mutually exclusive. More...
Static Public Attributes inherited from Ogre::v1::HardwareIndexBuffer
static const IndexType | IT_16BIT = Ogre::IT_16BIT
static const IndexType | IT_32BIT = Ogre::IT_32BIT

## Detailed Description

Specialisation of HardwareIndexBuffer for emulation.

## Constructor & Destructor Documentation

## ◆ GL3PlusDefaultHardwareIndexBuffer()

Ogre::v1::GL3PlusDefaultHardwareIndexBuffer::GL3PlusDefaultHardwareIndexBuffer | ( | IndexType | idxType,
|  | size_t | numIndexes,
|  | HardwareBuffer::Usage | usage )

## ◆ ~GL3PlusDefaultHardwareIndexBuffer()

Ogre::v1::GL3PlusDefaultHardwareIndexBuffer::~GL3PlusDefaultHardwareIndexBuffer | ( |  | ) |
| override

## Member Function Documentation

## ◆ getDataPtr()

void * Ogre::v1::GL3PlusDefaultHardwareIndexBuffer::getDataPtr | ( | size_t | offset | ) | const
| inline

## ◆ lock()

void * Ogre::v1::GL3PlusDefaultHardwareIndexBuffer::lock | ( | size_t | offset,
|  | size_t | length,
|  | LockOptions | options )
| overridevirtual

Override HardwareBuffer to turn off all shadowing.

Reimplemented from Ogre::v1::HardwareBuffer.

## ◆ readData()

void Ogre::v1::GL3PlusDefaultHardwareIndexBuffer::readData | ( | size_t | offset,
|  | size_t | length,
|  | void * | pDest )
| overridevirtual

Reads data from the buffer and places it in the memory pointed to by pDest.

Parameters

  offset | The byte offset from the start of the buffer to read
  length | The size of the area to read, in bytes
  pDest | The area of memory in which to place the data, must be large enough to accommodate the data!

Implements Ogre::v1::HardwareBuffer.

## ◆ unlock()

void Ogre::v1::GL3PlusDefaultHardwareIndexBuffer::unlock | ( |  | ) |
| overridevirtual

Override HardwareBuffer to turn off all shadowing.

Reimplemented from Ogre::v1::HardwareBuffer.

## ◆ writeData()

void Ogre::v1::GL3PlusDefaultHardwareIndexBuffer::writeData | ( | size_t | offset,
|  | size_t | length,
|  | const void * | pSource,
|  | bool | discardWholeBuffer = false )
| overridevirtual

Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough.

Parameters

  offset | The byte offset from the start of the buffer to start writing
  length | The size of the data to write to, in bytes
  pSource | The source of the data to be written
  discardWholeBuffer | If true, this allows the driver to discard the entire buffer when writing, such that DMA stalls can be avoided; use if you can.

Implements Ogre::v1::HardwareBuffer.

The documentation for this class was generated from the following file:

- OgreGL3PlusDefaultHardwareBufferManager.h